## mingw-w64-gnatformat-25.0.0-2.src.tar.zst

=== Makefile ===
BUILD_MODE ?= dev
LIBRARY_TYPE ?= static
PROCESSORS ?= 0

ALL_LIBRARY_TYPES = static static-pic relocatable
ALL_BUILD_MODES = dev prod

LIB_PROJECT = gnat/gnatformat.gpr

BIN_PROJECT = gnat/gnatformat_driver.gpr

TEST_PROGRAMS = testsuite/test_programs/partial_gnatformat.gpr

.PHONY: all
all: lib bin test-programs

.PHONY: lib
lib:
	for library_type in $(ALL_LIBRARY_TYPES) ; do \
		gprbuild \
			-v \
			-k \
			-XGNATFORMAT_LIBRARY_TYPE=$$library_type \
			-XLIBRARY_TYPE=$$library_type \
			-XGNATFORMAT_BUILD_MODE=$(BUILD_MODE) \
			-P $(LIB_PROJECT) \
			-p \
			-j$(PROCESSORS) ; \
	done;

.PHONY: bin
bin:
	gprbuild \
		-v \
		-k \
		-XGNATFORMAT_LIBRARY_TYPE=$(LIBRARY_TYPE) \
		-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
		-XGNATFORMAT_BUILD_MODE=$(BUILD_MODE) \
		-P$(BIN_PROJECT) \
		-p \
		-j$(PROCESSORS);

.PHONY: clean
clean:
	rm -rf bin;
	rm -rf lib;
	rm -rf obj;

.PHONY: install
install: install-lib install-bin

.PHONY: install-lib
install-lib:
	for library_type in $(ALL_LIBRARY_TYPES) ; do \
		gprinstall \
			-XGNATFORMAT_LIBRARY_TYPE=$$library_type \
			-XLIBRARY_TYPE=$$library_type \
			-XGNATFORMAT_BUILD_MODE=$(BUILD_MODE) \
			--install-name=gnatformat \
			--prefix="$(PREFIX)" \
			--sources-subdir=include/lal-refactor \
			--build-name=$$library_type \
			--build-var=LIBRARY_TYPE \
			-P $(LIB_PROJECT) -p -f ; \
	done ;

.PHONY: install-bin
install-bin:
	gprinstall \
		-XGNATFORMAT_LIBRARY_TYPE=$(LIBRARY_TYPE) \
		-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
		-XBUILD_MODE=$(BUILD_MODE) \
		--install-name=gnatformat_driver \
		--prefix="$(PREFIX)" \
		-P $(BIN_PROJECT) \
		-p \
		-f ;

.PHONY: test-programs
test-programs:
	for proj in $(TEST_PROGRAMS) ; do \
		gprbuild \
			-v \
			-k \
			-XGNATFORMAT_LIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XGNATFORMAT_BUILD_MODE=$(BUILD_MODE) \
			-P $$proj \
			-p \
			-j$(PROCESSORS) ; \
	done;

.PHONY: install-test-programs
install-test-programs:
	for proj in $(TEST_PROGRAMS) ; do \
		gprinstall \
			-XGNATFORMAT_LIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XLIBRARY_TYPE=$(LIBRARY_TYPE) \
			-XGNATFORMAT_BUILD_MODE=$(BUILD_MODE) \
			--prefix="$(PREFIX)" \
			--install-name=test_programs \
			--mode=usage \
			-P $$proj -p -f ; \
	done ;

.PHONY: test
test:
	python testsuite/testsuite.py

=== PKGBUILD ===
# Maintainer: Philipp Smirnov https://github.com/sad-poet

_realname=gnatformat
pkgbase=mingw-w64-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_realname}
pkgver=25.0.0
pkgrel=2
pkgdesc="An opinionated code formatter for the Ada language. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url="https://github.com/AdaCore/gnatformat"
license=("spdx:Apache-2.0 WITH LLVM-exception")
depends=(
  "${MINGW_PACKAGE_PREFIX}-gcc-ada"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-gnatcoll-core"
  "${MINGW_PACKAGE_PREFIX}-gnatcoll-gmp"
  "${MINGW_PACKAGE_PREFIX}-gnatcoll-iconv"
  "${MINGW_PACKAGE_PREFIX}-langkit_support"
  "${MINGW_PACKAGE_PREFIX}-libadalang"
  "${MINGW_PACKAGE_PREFIX}-libgpr"
  "${MINGW_PACKAGE_PREFIX}-libvss"
  "${MINGW_PACKAGE_PREFIX}-prettier-ada"
  "${MINGW_PACKAGE_PREFIX}-xmlada"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-gprbuild"
)
source=("https://github.com/AdaCore/gnatformat/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('722e0881a0954fb0cc948a7f9028a97a6f744373db400976fbf638d41af50a51')

build() {
  [[ -d "${srcdir}"/build-${MSYSTEM} ]] && rm -rf "${srcdir}"/build-${MSYSTEM}
  cp -r "${srcdir}/${_realname}-${pkgver}" "${srcdir}"/build-${MSYSTEM}
  cd "${srcdir}"/build-${MSYSTEM}

  BUILD_MODE=prod \
  LIBRARY_TYPE=relocatable \
  make lib bin
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}

  BUILD_MODE=prod \
  LIBRARY_TYPE=relocatable \
  make install PREFIX=${pkgdir}${MINGW_PREFIX}

  install -Dm644 -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}" \
    "${srcdir}/${_realname}-${pkgver}/LICENSE.txt"
}
